<?php
/* Prevent direct access */
defined('ABSPATH') or die("You can't access this file directly.");

add_action('wp_ajax_nopriv_ajaxsearchpro_autocomplete', 'ajaxsearchpro_autocomplete');
add_action('wp_ajax_ajaxsearchpro_autocomplete', 'ajaxsearchpro_autocomplete');
add_action('wp_ajax_nopriv_ajaxsearchpro_search', 'ajaxsearchpro_search');
add_action('wp_ajax_ajaxsearchpro_search', 'ajaxsearchpro_search');
add_action('wp_ajax_ajaxsearchpro_preview', 'ajaxsearchpro_preview');
add_action('wp_ajax_ajaxsearchpro_precache', 'ajaxsearchpro_precache');
add_action('wp_ajax_ajaxsearchpro_deletecache', 'ajaxsearchpro_deletecache');

require_once(ASP_PATH . "/includes/suggest/suggest.inc.php");

require_once(ASP_PATH . "/includes/etc/performance.class.php");

require_once(ASP_PATH . "/includes/imagecache.class.php");
require_once(ASP_PATH . "/includes/bfi_thumb.php");
require_once(ASP_PATH . "/includes/textcache.class.php");

/* Include the search core classes */
require_once(ASP_PATH . "/includes/search/search.inc.php");

if (!function_exists('ajaxsearchpro_search')) {
    function ajaxsearchpro_search($dontGroup = false) {
        global $asp_globals;

        $perf_options = get_option('asp_performance');

        if (w_isset_def($perf_options['enabled'], 1)) {
            $performance = new wpd_Performance('asp_performance_stats');
            $performance->start_measuring();
        }

        $s = $_POST['aspp'];
        $s = apply_filters('asp_search_phrase_before_cleaning', $s);

        $s = stripcslashes($s);
        $s = trim($s);
        $s = preg_replace('/\s+/', ' ', $s);

        $s = apply_filters('asp_search_phrase_after_cleaning', $s);

        $id = (int)$_POST['asid'];
        $sd = $asp_globals->instances[$id]['data'];

        if (get_option("asp_stat") == 1)
            asp_statistics::addKeyword($id, $s);

        $searchController = new asp_searchController(array(
            "phrase"    => $s,
            "id"        => $id,
            "instance"  => $asp_globals->instances[$id],
            "dontGroup" => $dontGroup
        ));

        $results = $searchController->search();

        if (count($results) <= 0 && $sd['keywordsuggestions']) {
            $results = $searchController->kwSuggestions();
        } else if (count($results > 0)) {
            $results = apply_filters('asp_only_non_keyword_results', $results);
        }

        $results = apply_filters('asp_results', $results, $id);

        do_action('asp_after_search', $s, $results, $id);

        if (w_isset_def($perf_options['enabled'], 1)) {
            $performance->stop_measuring();
            //$performance->dump_data();
        }

        // If preview, we need the details
        if (isset($_POST['action']) && $_POST['action'] == "ajaxsearchpro_preview") {
            print "wassup!";
            require_once(ASP_PATH . "backend" . DIRECTORY_SEPARATOR . "settings" . DIRECTORY_SEPARATOR . "types.inc.php");
            parse_str($_POST['formdata'], $preview_params);
            $preview_params = wpdreams_parse_params($preview_params);
            $preview_params = wp_parse_args( $preview_params, $sd );
            $html_results = asp_generate_html_results($results, $preview_params, $sd['resultstype']);
        } else {
            $html_results = asp_generate_html_results($results, $sd, $sd['resultstype']);
        }

        $searchController->setResCache($html_results);

        // Override from hooks.php
        if (isset($_POST['asp_get_as_array'])) {
            return $results;
        }

        /* Clear output buffer, possible warnings */
        print "!!ASPSTART!!";
        //var_dump($results);die();
        //print_r(json_encode($results));
        print_r($html_results);
        print "!!ASPEND!!";
        die();
    }
}

function ajaxsearchpro_autocomplete() {

    global $wpdb;
    $s = trim($_POST['sauto']);
    $s = preg_replace('/\s+/', ' ', $s);

    do_action('asp_before_autocomplete', $s);

    if (!isset($_POST['asid'])) return "";

    // Set the prefix for multisites
    if (isset($wpdb->base_prefix)) {
        $_prefix = $wpdb->base_prefix;
    } else {
        $_prefix = $wpdb->prefix;
    }

    // Forcing numeric value
    $_POST['asid'] = $_POST['asid'] + 0;

    $search = $wpdb->get_row($wpdb->prepare(
        "SELECT * FROM " . $_prefix . "ajaxsearchpro WHERE id=%d",
        $_POST['asid']
    ), ARRAY_A);

    if (!isset($search['data']))
        return;

    $sd = json_decode($search['data'], true);

    $keyword = '';
    $types = array();

    if ($sd['searchinposts'] == 1)
        $types[] = "post";
    if ($sd['searchinpages'] == 1)
        $types[] = "page";
    if (isset($sd['selected-customtypes']) && count($sd['selected-customtypes']) > 0)
        $types = array_merge($types, $sd['selected-customtypes']);

    foreach (w_isset_def($sd['selected-autocomplete_source'], array('google')) as $source) {

	    $taxonomy = "";
	    // Check if this is a taxonomy
	    if (strpos($source, 'xtax_') !== false) {
		    $taxonomy = str_replace('xtax_', '', $source);
		    $source = "terms";
	    }

        $t = new  wpd_keywordSuggest($source, array(
            'maxCount' => 10,
            'maxCharsPerWord' => $sd['autocomplete_length'],
            'postTypes' => $types,
            'lang' => $sd['keywordsuggestionslang'],
            'overrideUrl' => '',
	        'taxonomy' => $taxonomy,
            'match_start' => true
        ));

        $res = $t->getKeywords($s);
        if (isset($res[0]) && $keyword = $res[0])
            break;
    }

    do_action('asp_after_autocomplete', $s, $keyword);
    print $keyword;
    die();

}

function ajaxsearchpro_preview() {
    require_once(ASP_PATH . "/includes/shortcodes.php");
    $o = aspShortcodeContainer::get_instance();
    $out = $o->wpdreams_asp_shortcode(array(
        "id" => $_POST['asid']
    ));
    print $out;
    die();
}

/* Delete the cache */
function ajaxsearchpro_deletecache() {
    $count = 0;
    function delTree($dir) {
        $count = 0;
        $files = @glob($dir . '*', GLOB_MARK);
        foreach ($files as $file) {
            if (substr($file, -1) == '/')
                @delTree($file);
            else
                @unlink($file);
            $count++;
        }
        return $count;
    }

    print delTree(ASP_PATH . DIRECTORY_SEPARATOR . "cache" . DIRECTORY_SEPARATOR);
    exit;
}

function ajaxsearchpro_deletekeyword() {
    if (isset($_POST['keywordid'])) {
        echo asp_statistics::deleteKw($_POST['keywordid'] + 0);
        exit;
    }
    echo 0;
    exit;
}